/***************************************************************************
                          dialdialogimp.h  -  description
                             -------------------
    begin                : Wed Dec 26 2001
    copyright            : (C) 2001 by Robin Atwood
    email                : robin.atwood@attglobal.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DIALDIALOGIMP_H
#define DIALDIALOGIMP_H

#include <qtooltip.h>
#include <qcheckbox.h>
//Added by qt3to4:
#include <QKeyEvent>
#include <kapplication.h>
#include <klineedit.h>
#include <kcursor.h>
#include <kmessagebox.h>
#include <khelpmenu.h>
#include <ktoolinvocation.h>

#include <KUrl>
#include <akonadi/collection.h>
#include <akonadi/job.h>
#include <akonadi/itemfetchjob.h>
#include <akonadi/itemfetchscope.h>
#include <akonadi/itemsearchjob.h>
#include <akonadi/item.h>

#include "modemcomms.h"
#include "ui_dialdialog.h"
#include "kallglobals.h"
#include "configdialogimp.h"
#include "kall.h"



/**
  *@author Robin Atwood
  */

class DialDialog : public QDialog, private Ui::DialDialog, virtual public KallGlobals
{
	Q_OBJECT
	public:
    DialDialog( QWidget* parent = 0, Qt::WFlags fl = 0 );
		~DialDialog();

		void setDialInfo( const QString& number );
		void getDialInfo( QString&, QString&, QString& );
			
	protected:
		bool dialling;
		int  redialCount;
		void keyPressEvent( QKeyEvent *qkeyevent );		
		ModemComms *modem;
		QTimer	  	*busyTimer, *redialTimer;

    bool dialNumber( QString );
    void hangUp();
		
	protected slots:	
		void slotDialHangup();
		void slotDialCancel();
		void slotDialConfig();
		void slotDialHelp();
		void slotLogButton();
		void slotBusyTimeout();
		void slotRedialTimeout();
		void slotEditChanged( const QString& );
		void slotFetchedItem( KJob * );
		void slotSearchJob( KJob * );
		void slotIndexChanged( int );
		void slotClearEdit();
		void slotFetchJob( KJob * );
		
	private:
		KLineEdit *dialLineEdit;
		bool locked;
		int  intvlLeft;
		QAction *confItem, *viewItem, *helpItem;
    QString mNumber;
    
		void addNumbers( const KABC::Addressee& contact );
		void resetDialBtn();
		void setStatusBar( const QString & );
};

#endif
