/***************************************************************************
                          kallglobals.h  -  description
                             -------------------
    begin                : Fri Feb 15 2002
    copyright            : (C) 2002 by Robin Atwood
    email                : robin.atwood@attglobal.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KALLGLOBALS_H
#define KALLGLOBALS_H

#define KDE_NO_COMPAT

/**This class contains various global variables
	 and utility routines used by all the main views.	
  *@author Robin Atwood
  */

/*
 * Defines in case locale does not work.
 */	

#define IDD_CODE    	"00"
#define LD_CODE     	"0"
#define LOCALE_CODE 	"44"				

#define MODEM_DEVICE	"/dev/modem"
#define MODEM_INIT1		"ATZ"
#define MODEM_INIT2		"ATS11=55 S0=0 E0 L2 M2 Q0 V1 X4 &C0 &D1"
#define MODEM_DIAL		"ATDT"
#define MODEM_HANGUP	"ATH0"

#include <qdir.h>
#include <qprinter.h>
#include <qpainter.h>
#include <qcheckbox.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qtimer.h>
#include <qstring.h>
#include <qwidget.h>
#include <qpixmap.h>
#include <qfile.h>

#include <klocale.h>
#include <kstandarddirs.h>
#include <kstatusbar.h>
#include <kabc/addressee.h>
#include <kconfig.h>
#include <kconfiggroup.h>

using namespace KABC;

class KallApp;

class KallGlobals
{
  public:
  	KallGlobals();
  	~KallGlobals();

	protected:

    struct loginf { QString name, org, number, sdate, start, etime, status; };
//    enum { Home = 1, Work = 2, Msg = 4, Pref = 8, Voice = 16, Fax = 32,
//           Cell = 64, Video = 128, Bbs = 256, Modem = 512, Car = 1024,
//           Isdn = 2048, Pcs = 4096, Pager = 8192 };

 		static KallApp     *kall;

    KSharedConfigPtr config;
		KConfigGroup *genGroup, *teleGroup, *modemGroup;

    static QString modemInit1, modemInit2, modemDial, modemHangup, modemDevice, modemDeviceDflt;
    static QString iddCode, ldCode, localeCode, iddCodeDflt, ldCodeDflt, localeCodeDflt;
    static QString logfn;
    static int maxRetry, intvlRetry;
		static bool mwMode;

    static const int MAXPHONES = 13;
    struct t_phonetypes{ int type; QString name; };
    static const t_phonetypes phonetypes[MAXPHONES];

		void localise( QString & );
};

#endif
