/***************************************************************************
                          logview.cpp  -  description
                             -------------------
    begin                : Thu Jan 10 2002
    copyright            : (C) 2002 by Robin Atwood
    email                : robin.atwood@attglobal.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "logviewdialogimp.h"
//Added by qt3to4:
#include <Q3TextStream>
#include <QPixmap>

LogViewDialogImp::LogViewDialogImp( QWidget *parent ) :
  QDialog(  parent ),
	Ui::LogViewDialog()
{
	setupUi( this );
	buttonCancel->setIcon(KIcon("dialog-close"));
	setWindowTitle( i18n("Call History Viewer") );

  QFile f( logfn );
  if ( !f.open( QIODevice::ReadOnly ) )
  {
  	KMessageBox::sorry( this, i18n("Log file does not exist!"), i18n("Warning") );
  }
  else
  {
    char buf[4096];

    while ( true )
    {
    	int pos = 0, npos, k;
    	QString items; 
			QStringList itemList;
			
      qint64 l = f.readLine( buf, sizeof(buf) );
			if ( l < 0 ) break;
			
			items = QString( buf ).left( l-1 );
    	for ( k = 0; k < 6; ++k )
    	{
    		npos = items.indexOf( '\t', pos );
    		itemList << items.mid( pos, npos-pos );
    		pos = npos + 1;
    	}
    	
  		QTreeWidgetItem *row = new QTreeWidgetItem( rows, itemList );
			
			if ( itemList[5] == "OK" )
				row->setIcon( 0, KIcon("user-online") );
			else if ( itemList[5] == "Busy" )
				row->setIcon( 0, KIcon("user-busy") );
			else if ( itemList[5] == "No Answer" )
				row->setIcon( 0, KIcon("user-offline") );
			else 
				row->setIcon( 0, KIcon("user-invisible") );
    }
    
    f.close();
    rows->sortItems( 0, Qt::DescendingOrder );												// newest calls at top
  }
  	
  buttonCancel->setFocus();
}

LogViewDialogImp::~LogViewDialogImp()
{
}



