/***************************************************************************
                          modemcomms.h  -  description
                             -------------------
    begin                : Sat Dec 22 2001
    copyright            : (C) 2001 by Robin Atwood
    email                : robin.atwood@attglobal.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MODEMCOMMS_H
#define MODEMCOMMS_H


/**Simple io to a modem connected to a serial port.
   The UUCP locking protocol is observed.

  *@author Robin Atwood
  */

#include <sys/types.h>
#include <sys/stat.h>
#include <signal.h>
#include <fcntl.h>
#include <termios.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <iostream>

/* baudrate settings are defined in <asm/termbits.h>, which is
   included by <termios.h> */

#define BAUDRATE B115200
#define LOCKDIR "/var/lock/LCK.."
#define _POSIX_SOURCE 1 									 /* POSIX compliant source */

class ModemComms
{
  private:
  	int fd;
		bool locked;
  	struct termios oldtio,newtio;
  	char buf[255], port[16], lockfile[32];

    void readPort();
		void writePort( const char[] );

  public:
		ModemComms( const char[] );
    int initPort();
    void closePort();
		bool modemIO( const char [] );
		bool lockDevice();
		bool unlockDevice();
	  char * getResp();
	  void setICanon( bool );
};

#endif
