/***************************************************************************
                          statusdialogimp.cpp  -  description
                             -------------------
    begin                : Mon Mar 4 2002
    copyright            : (C) 2002 by Robin Atwood
    email                : robin.atwood@attglobal.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "statusdialogimp.moc"
//Added by qt3to4:
#include <QPixmap>
#include <QMenu>
#include <QTextStream>

using namespace std;

StatusDialogImp::StatusDialogImp( QWidget* parent, Qt::WFlags fl ) :
  QDialog( parent, fl ),
	Ui::StatusDialog()
{
	setupUi( this );
 	statusTimer = new QTimer( this );
  connect( statusTimer, SIGNAL( timeout() ), this, SLOT( slotStatusTimeout() ) );

 	statusButtonOK->setFocus();
 	statusButtonOK->setIcon(KIcon("dialog-ok"));
 	statusButtonCancel->setIcon(KIcon("dialog-cancel"));
	
	statusCombo->setItemIcon( 0, KIcon("user-online") );
	statusCombo->setItemIcon( 1, KIcon("user-busy") );
	statusCombo->setItemIcon( 2, KIcon("user-offline") );
	statusCombo->setItemIcon( 3, KIcon("user-invisible") );
}

StatusDialogImp::~StatusDialogImp()
{
}

void StatusDialogImp::showStats( QString &name, QString &number, QString &org )
{
 	loginf	loginfo;
 	QDate 	d = QDate::currentDate();	
 	QString dd;
	
 	tstamp.start();
 	loginfo.name = name;
 	loginfo.number = number;
 	loginfo.org = org;
	loginfo.sdate = dd.sprintf( "%04d/%02d/%02d", d.year(), d.month(), d.day() );
 	loginfo.start = tstamp.toString();
	
	timeLabel->setText( "00:00:00" );
	status = "OK";
	
	setToolTip( "<pre><b>Person:</b>       " + name + 
							"<br><b>Number:</b>       " + number +
							"<br><b>Organisation:</b> " + org +
							"</pre>" );

 	statusTimer->start( 1000 );
 	int res = exec();
 	statusTimer->stop();

 	if ( res == QDialog::Accepted )
 	{
 		QTime t( 0, 0, 0 );
 		t = t.addMSecs( tstamp.elapsed() );
 		loginfo.etime = t.toString();
		loginfo.status = status;
 		
    QFile f( logfn );
		if ( f.open( QIODevice::WriteOnly|QIODevice::Append ) )
		{
      QTextStream logfile( &f );
  		logfile << loginfo.sdate << "  " << loginfo.start << '\t' << loginfo.name.toLatin1()  << '\t'
              << loginfo.org.toLatin1() << '\t' << loginfo.number << '\t' << loginfo.etime
  						<< '\t' << loginfo.status << '\t' << endl;
			f.close(); 		
		}
		else
			cerr << "Log file " << logfn.toLatin1().data() << " failed to open" << endl;
 	}
}

void StatusDialogImp::slotStatusTimeout()
{
 	QTime t( 0, 0, 0 );
 	t = t.addMSecs( tstamp.elapsed() );
 	timeLabel->setText( t.toString( "hh:mm:ss" ) );
} 	

void StatusDialogImp::slotStatus( QString text )
{
	status = text;
}

